jQuery.fn.exists = function () {
    return this.length !== 0;
}

jQuery(document).ready(function () {

    var that = this;

    window.GCMHTML = {

        bannerCookieName: 'gcmdata_',

        isBannerCookieGCMCookie: true,

        getXPath: function (element) {
            $element = jQuery(element);
            var selector = $element
                .parents()
                .map(function () {
                    var returnValue = this.tagName.toLowerCase();
                    var id = jQuery(this).attr('id');

                    if (typeof id != 'undefined' && id.trim().length > 0) {
                        returnValue = '#' + id;
                    }

                    return returnValue;
                })
                .get()
                .reverse()
                .concat([this.nodeName])
                .join(">");

            var id = $element.attr("id");
            if (id) {
                selector += "#" + id;
            }

            var classNames = jQuery(element).attr("class");

            if (classNames && classNames.length > 0) {
                selector += "." + jQuery.trim(classNames).replace(/\s/gi, ".");
            } else {
                return '';
            }

            return selector;
        },
        setCookie: function (cookieName, cookieValue, expDays) {
            var d = new Date();
            d.setTime(d.getTime() + (expDays * 24 * 60 * 60 * 1000));
            var expires = "expires=" + d.toUTCString();
            var path = "path=/";
            document.cookie = cookieName + "=" + cookieValue + "; " + expires + "; " + path;
        },
        deleteCookie: function (cookieName) {
            window.GCMHTML.setCookie(cookieName, ' ', 0);
        },

        isCookiesAllowed: function () {
            var cookies = document.cookie;

            if (typeof cookies === 'undefined' || cookies === null) {
                return false;
            }
            return (cookies.indexOf(this.bannerCookieName) >= 0);
        },

        applications: [],

        groups: [],

        postprocessingDOMElements: [],

        addPPDom: function (element) {
            window.GCMHTML.postprocessingDOMElements.push(element);
        },

        renderPPDomElements: function () {

            jQuery('iframe[src*=youtube]').each(function (index, element) {

                jQuery(jQuery(this).parent()).css('background-image', 'transparent');
                jQuery('.preferences-button').hide();
                jQuery(jQuery(jQuery(this).parent()).find('h2')).hide();

                jQuery(this).show(); // ('display', 'none');
            });


            /*
            window.GCMHTML.postprocessingDOMElements.forEach(function(iFrame) {
                if(typeof iFrame.render === 'function') {
                    iFrame.render();
                }
            });
            */
        },
        youtubeToggledActive: false,
        renderPostHTML() {

            // if youtube toggeld to active

            if (this.youtubeToggledActive === true) {
                jQuery('.bodyWrapper .youtube-wrapper').each(function (index, ywrapper) {
                    jQuery(ywrapper).css('background', 'none');
                    jQuery(ywrapper).css('background-color', 'rgb(115,122,120)');


                    jQuery(jQuery(ywrapper).find('.preferences-button')).addClass('testOFF');
                    jQuery(jQuery(ywrapper).find('h2')).addClass('testOFF');

                    var iFrame = jQuery(ywrapper).find('iframe');

                    jQuery(iFrame).attr('src', jQuery(iFrame).data('src'));
                    jQuery(iFrame).show();
                });
            }

            this.youtubeToggledActive = false;
        },
        bannerText: 'Wir ersuchen um Ihre Zustimmung für Cookies. Wir setzen technisch notwendige, funktionelle und '
            + 'Marketing-Cookies ein. Marketing-Cookies werden erst mit Ihrer Zustimmung und ausschließlich für '
            + 'statistische Zwecke verwendet, unsere Websites sind werbefrei. Bis auf die technisch notwendigen sind '
            + 'alle Cookies zu Beginn deaktiviert. Nähere Informationen finden Sie in unserer '
            + '<a class="apa-consent-reset" href="https://www.apa.at/Site/datenschutz/datenschutzerklaerung.html" target="_blank">Datenschutzerklärung</a>.'
            + ' Eine detaillierte Übersicht der Cookies finden Sie in den '
            + '<a class="apa-consent-reset apa-consent-linkDetails" href="javascript:void(0)">Cookie-Präferenzen</a>.',

        bannerTextEN: 'We request your consent for cookies. We use technically necessary, functional and marketing '
            + 'cookies. Marketing cookies are only used with your consent and exclusively for statistical purposes; '
            + 'our websites are free of advertisement. Except for the technically necessary cookies, all cookies are '
            + 'disabled from the outset. Further information can be found in our privacy statement to be found at'
            + ' <a class="apa-consent-reset"  href="https://www.apa.at/privacypolicy" target="_blank">privacypolicy</a>. '
            + 'A detailed overview of the cookies can be found in the cookie preferences.',

        hideClass: 'testOFF',
        bannerWrapper: jQuery('.apa-consent-wrapper')[0],
        banner: jQuery('.apa-consent-banner')[0],
        bannerButtonAccept: jQuery('.apa-consent-buttonWrapperAccept')[0],
        bannerButtonOpen: jQuery('.apa-consent-bannerButtonON')[0],

        /**
         * prefDialogRoundButtonOpen is inside apa-consent-wrapper, which is the banner wrapper
         */
        prefDialogRoundButtonOpen: jQuery('.apa-consent-bannerButtonOFF')[0],

        hidePrefDialogRoundButtonOpen: function () {
            jQuery(this.prefDialogRoundButtonOpen).addClass(this.hideClass);
        },
        prefDialog: jQuery('.apa-consent-dialogWrapper')[0],

        prefDialogButtonSaveSettings: jQuery('.apa-consent-dialogSubmit')[0],

        /**
         * prefDialogButtonOpen & prefDialogButtonDetails have the same function...
         */
        prefDialogButtonOpen: jQuery('.apa-consent-dialogButtonON')[0],

        // two buttons!
        prefDialogButtonDetails: jQuery('.apa-consent-buttonWrapperDetails')[0],

        prefDialogButtonClose: jQuery('.apa-consent-dialogButtonOFF')[0],

        hidePrefDialogButtonClose: function () {
            jQuery(this.prefDialogButtonClose).addClass(this.hideClass);
        },

        showPrefDialogButtonClose: function () {
            jQuery(this.prefDialogButtonClose).removeClass(this.hideClass);
        },

        prefDialogButtonMobileClose: jQuery('.apa-consent-mobileClose')[0],

        showOrHideBanner: function () {

            if (this.isCookiesAllowed()) {
                this.hideBanner(true);
                this.showPrefDialogButtonOpen();
                return false;
            } else {
                this.showBanner();
                return true;
            }
        },
        hideBanner: function (prefDialogMode) {

            if (typeof prefDialogMode === 'undefined' || prefDialogMode === null) {
                prefDialogMode = false;
            }

            jQuery(this.banner).addClass(window.GCMHTML.hideClass);

            // bannerWrapper needs to be off, cause it would overlap a button to open prefDialog
            jQuery(this.bannerWrapper).addClass(window.GCMHTML.hideClass);

            if (prefDialogMode) {
                jQuery(this.bannerButtonOpen).addClass(window.GCMHTML.hideClass);
                jQuery(this.prefDialogButtonOpen).removeClass(window.GCMHTML.hideClass);

            } else {
                jQuery(this.bannerButtonOpen).removeClass(window.GCMHTML.hideClass);
                jQuery(this.prefDialogButtonOpen).addClass(window.GCMHTML.hideClass);
            }
        },
        showBanner: function () {

            jQuery(this.bannerWrapper).removeClass(window.GCMHTML.hideClass);
            jQuery(this.banner).removeClass(window.GCMHTML.hideClass);
            jQuery(this.bannerButtonOpen).addClass(window.GCMHTML.hideClass)
            jQuery(this.bannerButtonOpen).addClass(window.GCMHTML.hideClass)
        },

        hideBannerButtonOpen: function () {
            jQuery(this.bannerButtonOpen).removeClass(window.GCMHTML.hideClass);
            jQuery(this.prefDialogButtonOpen).addClass(window.GCMHTML.hideClass);
        },

        showPrefDialogButtonOpen: function () {
            jQuery(this.bannerButtonOpen).addClass(window.GCMHTML.hideClass);
            jQuery(this.prefDialogButtonOpen).removeClass(window.GCMHTML.hideClass);
        },

        showPrefDialog: function () {
            // this.hideBanner(true);

            // we need to display bannerWrapper, cause it gets turned of by previouse method hideBanner...
            jQuery(this.bannerWrapper).removeClass(window.GCMHTML.hideClass);

            jQuery(this.prefDialog).removeClass(window.GCMHTML.hideClass);
            jQuery(this.prefDialogButtonOpen).addClass(window.GCMHTML.hideClass);

            window.GCMHTML.showPrefDialogButtonClose();

            //window.GCMHTML.showPrefDialogButtonOpen()
            // window.GCMHTML.hidePrefDialogRoundButtonOpen();
        },
        hidePrefDialog: function () {
            jQuery(this.bannerWrapper).addClass(window.GCMHTML.hideClass);
            jQuery(this.prefDialog).addClass(window.GCMHTML.hideClass);

            window.GCMHTML.hidePrefDialogButtonClose();

            if (window.GCMHTML.isCookiesAllowed()) {
                jQuery(this.bannerButtonOpen).addClass(window.GCMHTML.hideClass);
                jQuery(this.prefDialogButtonOpen).removeClass(window.GCMHTML.hideClass);
            } else {
                jQuery(this.prefDialogButtonOpen).addClass(window.GCMHTML.hideClass);

                this.showBanner();
            }

        }
        ,
        eventButtonAccept: function () {

            jQuery(document).on('click', this.getXPath(this.bannerButtonAccept), function (event) {

                if (!window.GCMHTML.isBannerCookieGCMCookie) {
                    window.GCMHTML.setCookie(window.GCMHTML.bannerCookieName, 'true', 365);
                }


                var groupKeys = Object.keys(window.GCM.groups.getList());

                groupKeys.forEach(function (group, index) {
                    window.GCM.groups.set(group, true);

                });

                window.GCM.settings.save();

                window.GCMHTML.hideBanner(true);

                window.GCMHTML.renderPostHTML();
            });
        },
        eventButtonSaveSettings: function () {

            jQuery(this.prefDialogButtonSaveSettings).click(function (event) {

                if (!window.GCMHTML.isBannerCookieGCMCookie) {
                    window.GCMHTML.setCookie(window.GCMHTML.bannerCookieName, 'true', 365);
                }

                window.GCMHTML.hideBanner();
                window.GCMHTML.hideBannerButtonOpen();
                window.GCMHTML.showPrefDialogButtonOpen();

                /* TODO CHECK FOLLOWING LINES
                window.GCMHTML.groups.forEach(function (group) {

                    // todo auf group.protected prüfen
                    if (!group.protected && window.GCMHTML.isGroupActive(group)) {

                        var keys = Object.keys(group.gcmGroup.apps);

                        keys.forEach(function (app) {

                            var application = group.gcmGroup.apps[app];

                            console.log(application);
                            console.log(app + '_' + application.value);

                            window.GCM.apps.setAndSave(app, application.value);

                        });

                        window.GCM.groups.setAndSave(group.groupid, window.GCMHTML.isGroupActive(group));
                    } else if (!group.protected) {
                        // BUG setAndSave delete cookies from all groups...
                        // window.GCM.groups.setAndSave(group.groupid, window.GCMHTML.isGroupActive(group));
                        // window.GCM.groups.set(group.groupid, false);

                        var appKeys = Object.keys(group.gcmGroup.apps);

                        appKeys.forEach(function (app, index) {

                            var appObject = group.gcmGroup.apps[app];

                            appObject.value = false;

                            window.GCM.apps.setAndSave(appObject.appid, false);
                        });
                    }


                    if (document.cookie.indexOf('cookiesAllowed=true') == -1) {
                        window.GCMHTML.setCookie("cookiesAllowed", 'true', 365);
                    }

                });
                */

                window.GCM.settings.save();

                window.GCMHTML.hidePrefDialog();

                window.GCMHTML.renderPostHTML();
            });
        },
        addGroup: function (groupid, gcmGroup, htmlGroup) {
            var group = {
                groupid: groupid,
                gcmGroup: gcmGroup,
                htmlGroup: htmlGroup
            }

            this.groups.push(group);
            return group;
        },
        isGroupActive: function (group) {
            var result = false;

            jQuery.each(group.gcmGroup.apps, function (index, app) {
                if (app.value) {
                    result = true;
                }
            });

            return result;
        },

        activateGroup: function (group) {
            // activate all application cookies...
            this.activateCookiesByGroup(group);

            //updateApplication(application);
            //window.GCM.apps.set(application.appid, true);
            group.gcmGroup.value = true;
            window.GCM.groups.set(group.groupid, true);
        },
        deactivateAllGroups: function () {
            window.GCMHTML.groups.forEach(function (group) {
                if (!group.gcmGroup.protected) {
                    window.GCMHTML.deactivateGroup(group);
                }
            });
        },

        deactivateGroup: function (group) {
            // deactivate all application cookies...
            this.deactivateCookiesByGroup(group);

            // deactivate all cookies ?
            // window.GCM.apps.set(application.appid, false);

            window.GCM.groups.set(group.groupid, false);
        },
        loadGroup: function (group) {
            this.renderGroupHTMLFields(group);
            this.initGroupToggleSwitch(group);
        },
        activateGroupSwitchOnly: function (group) {

            var consentSwitch = jQuery(document).find('#' + group.gcmGroup.htmlid + ' .apa-consent-itemSwitch')[0];

            $consentSwitch = jQuery(consentSwitch);

            $consentSwitch.addClass('apa-consent-itemSwitchON');
            $consentSwitch.removeClass('apa-consent-itemSwitchOFF');
        },
        activateGroupSwitch: function (group) {

            var consentSwitch = jQuery(document).find('#' + group.gcmGroup.htmlid + ' .apa-consent-itemSwitch')[0];

            $consentSwitch = jQuery(consentSwitch);

            $consentSwitch.addClass('apa-consent-itemSwitchON');
            $consentSwitch.removeClass('apa-consent-itemSwitchOFF');


            window.GCMHTML.activateGroup(group);
        },
        deactivateGroupSwitchOnly: function (group) {

            var consentSwitch = jQuery('#' + group.gcmGroup.htmlid).find('.apa-consent-itemSwitch')[0];

            $consentSwitch = jQuery(consentSwitch);

            $consentSwitch.removeClass('apa-consent-itemSwitchON');
            $consentSwitch.addClass('apa-consent-itemSwitchOFF');
        },
        deactivateGroupSwitch: function (group) {

            $consentSwitch = jQuery('#' + group.gcmGroup.htmlid).find('.apa-consent-itemSwitch');

            $consentSwitch.removeClass('apa-consent-itemSwitchON');
            $consentSwitch.addClass('apa-consent-itemSwitchOFF');

            window.GCMHTML.deactivateGroup(group);
        },
        toggleGroupSwitch: function (group) {
            if (group.gcmGroup.protected) {
                return;
            } else if (!window.GCMHTML.isGroupActive(group)) {
                window.GCMHTML.activateGroupSwitch(group);
            } else {
                window.GCMHTML.deactivateGroupSwitch(group);
            }
        },
        initGroupToggleSwitch: function (group) {

            if (group.protected) {
                return;
            }

            /*
            if (typeof group.gcmGroup.value === 'undefined' || group.gcmGroup.value === null
                || group.gcmGroup.value || this.isGroupActive(group)) {
                this.activateGroupSwitch(group);
            } else {
                this.deactivateGroupSwitch(group);
            }
            */

            jQuery(document).on('click', '#' + group.gcmGroup.htmlid + ' .apa-consent-itemSwitch',
                function (event) {

                    /*
                        const applications = group.gcmGroup.apps;

                        jQuery.each(applications, function (index, application) {

                            if(application.value) {

                                // at least an application is active, so deactivate all cookies.

                                return false;
                            }
                        });
                    */

                    window.GCMHTML.toggleGroupSwitch(group);

                    var appList = window.GCM.apps.getList();
                    // TODO remove hardcoded access...
                    if (!appList['gcm'] && group.gcmGroup.value) {

                        var groups = window.GCMHTML.groups;

                        jQuery.each(groups, function (index, funcGroup) {
                            if (funcGroup.groupid === 'functional') {
                                // activate gcm
                                var appKeys = Object.keys(appList);
                                jQuery.each(appKeys, function (index, app) {

                                    var appObject = funcGroup.gcmGroup.apps['gcm'];

                                    if (app === 'gcm') {

                                        console.log(appObject);
                                        window.GCMHTML.activateCookiesByApplication(funcGroup, appObject);
                                    }
                                });
                            }
                        });
                    }
                });
        },
        initGroupCookieToggleSwitch: function (group, application, gcmCookieName, gcmCookie, htmlCookie) {

            if (group.protected) {
                // no click event intendend.
                return;
            }

            var gcmGroup = group.gcmGroup;
            var htmlGroup = group.htmlGroup;


            $htmlGroup = jQuery(htmlGroup);
            $htmlCookie = jQuery(htmlCookie);

            var cookieSelector = '#' + $htmlGroup.attr('id') + ' #' + $htmlCookie.attr('id')
                + ' .apa-consent-subItemTitle';


            if (!window.GCMHTML.isGroupActive(group)) {
                // deactivate cookie
                window.GCMHTML.deactivateCookiesByGroup(group);

            }

            if (!application.value) {
                window.GCMHTML.deactivateCookiesByApplication(group, application);
            }

            jQuery('body').on('click', cookieSelector, function (event) {

                if (group.gcmGroup.protected) {
                    return;
                }


                if (application.appName === 'youtube' && window.GCMHTML.isCookieDeactivate(gcmGroup.htmlid, gcmCookie.htmlid)) {
                    // youtube was activated.
                    window.GCMHTML.youtubeToggledActive = true;
                } else if (application.appName === 'youtube' && !window.GCMHTML.isCookieDeactivate(gcmGroup.htmlid, gcmCookie.htmlid)) {
                    window.GCMHTML.youtubeToggledActive = false;
                }


                if ((gcmCookieName === window.GCMHTML.bannerCookieName || (window.GCMHTML.isBannerCookieGCMCookie && gcmCookieName.startsWith(window.GCMHTML.bannerCookieName))) && !window.GCMHTML.isCookieDeactivate(gcmGroup.htmlid,
                    gcmCookie.htmlid)) {

                    window.GCMHTML.deactivateCookiesAll();
                    window.GCMHTML.deactivateAllGroups();
                    window.GCMHTML.deactivateGroupSwitchOnly(group);


                } else if ((gcmCookieName === window.GCMHTML.bannerCookieName || (window.GCMHTML.isBannerCookieGCMCookie && gcmCookieName.startsWith(window.GCMHTML.bannerCookieName)))) {

                    window.GCMHTML.activateCookie(gcmGroup.htmlid, gcmCookie.htmlid);

                    if (!window.GCMHTML.isGroupActive(group)) {
                        // this method is a patch ..., merge this with toggleGroupSwitch
                        window.GCMHTML.activateGroupSwitchOnly(group);
                    }

                    window.GCM.apps.setAndSave(application.appName, true);

                } else if (gcmCookieName.startsWith('gcmdata_') && !window.GCMHTML.isCookieDeactivate(gcmGroup.htmlid,
                    gcmCookie.htmlid)) {


                    window.GCMHTML.deactivateCookiesAll([window.GCMHTML.bannerCookieName]);

                    window.GCMHTML.groups.forEach(function (group) {
                        if (!group.protected) {
                            window.GCM.groups.set(group.groupid, false);
                        }
                    });


                } else if (gcmCookieName.startsWith('gcmdata_')) {
                    window.GCMHTML.activateCookie(gcmGroup.htmlid, gcmCookie.htmlid);


                } else if (window.GCMHTML.isCookieDeactivate(gcmGroup.htmlid, gcmCookie.htmlid)) {

                    window.GCMHTML.activateCookiesByApplication(group, application);

                    var appList = window.GCM.apps.getList();
                    // TODO remove hardcoded access...
                    if (!appList['gcm']) {

                        var groups = window.GCMHTML.groups;

                        jQuery.each(groups, function (index, funcGroup) {
                            if (funcGroup.groupid === 'functional') {
                                // activate gcm
                                var appKeys = Object.keys(appList);
                                jQuery.each(appKeys, function (index, app) {

                                    var appObject = funcGroup.gcmGroup.apps['gcm'];

                                    if (app === 'gcm') {

                                        console.log(appObject);
                                        window.GCMHTML.activateCookiesByApplication(funcGroup, appObject);
                                    }
                                });
                            }
                        });
                    }

                    window.GCM.apps.set(application.appName, true);

                    window.GCMHTML.activateGroupSwitchOnly(group);


                } else if (!window.GCMHTML.isCookieDeactivate(gcmGroup.htmlid, gcmCookie.htmlid)) {

                    window.GCMHTML.deactivateCookiesByApplication(group, application);
                    window.GCM.apps.set(application.appName, false);
                    window.GCMHTML.deactivateGroupSwitchOnly(group);
                }
            });
        },

        activateCookie: function (htmlApplicationId, htmlCookieId) {
            var htmlCookie = jQuery('body #' + htmlApplicationId + ' #' + htmlCookieId);

            htmlCookie.removeClass('apa-consent-itemSubItemOFF');
        },
        activateCookiesByPrefix: function (application, prefix) {
            jQuery.each(application.gcmApplication.cookies, function (index, cookie) {
                if (cookie.label.toLowerCase().startsWith(prefix.toLowerCase())) {
                    window.GCMHTML.activateCookie(application.gcmApplication.htmlid, cookie.htmlid);
                }
            });
        },

        activateCookiesByGroup: function (group) {
            jQuery.each(group.gcmGroup.apps, function (index, app) {
                app.value = true;
                jQuery.each(app.cookies, function (index, cookie) {
                    window.GCMHTML.activateCookie(group.gcmGroup.htmlid, cookie.htmlid);
                });
            });
        },

        deactivateCookiesByGroup: function (group) {

            jQuery.each(group.gcmGroup.apps, function (index, app) {
                app.value = false;
                jQuery.each(app.cookies, function (index, cookie) {
                    window.GCMHTML.deactivateCookie(group.gcmGroup.htmlid, cookie.htmlid);
                });
            });
        },

        activateCookiesByApplication: function (group, application) {

            window.GCM.apps.set(application.appName, true);

            jQuery.each(application.cookies, function (index, cookie) {
                window.GCMHTML.activateCookie(group.gcmGroup.htmlid, cookie.htmlid, group.htmlGroup);
            });

            /*
            jQuery.each(group.gcmGroup.apps, (index, app) => {
                if (application == app) {
                    jQuery.each(app.cookies, (index, cookie) => {
                        this.activateCookie(group.gcmGroup.htmlid, cookie.htmlid);
                    });
                }
            });
            */
        },
        isActivateCookie: function (htmlApplicationId, htmlCookieId) {
            var htmlCookie = jQuery('body #' + htmlApplicationId + ' #' + htmlCookieId);

            // opposite cond, jquery bug?
            if (htmlCookie.hasClass('apa-consent-itemSubItemOFF')) {
                return true;
            }

            return false;
        },
        isCookieDeactivate: function (htmlApplicationId, htmlCookieId) {
            var htmlCookie = jQuery('body #' + htmlApplicationId + ' #' + htmlCookieId);

            return htmlCookie.hasClass('apa-consent-itemSubItemOFF');
        },

        deactivateCookie: function (htmlApplicationId, htmlCookieId, htmlApplication) {

            if (typeof htmlApplication !== 'undefined') {

                var htmlCookie = jQuery('body #' + htmlApplicationId + ' #' + htmlCookieId);

                htmlCookie.addClass('apa-consent-itemSubItemOFF');

            } else {
                var htmlCookie = jQuery('body #' + htmlApplicationId + ' #' + htmlCookieId);

                htmlCookie.addClass('apa-consent-itemSubItemOFF');
            }
        },
        deactivateCookiesByPrefix: function (application, prefix) {
            jQuery.each(application.gcmApplication.cookies, function (index, cookie) {
                if (cookie.label.toLowerCase().startsWith(prefix.toLowerCase())) {
                    window.GCMHTML.deactivateCookie(application.gcmApplication.htmlid, cookie.htmlid);
                }
            });
        },
        deactivateCookiesByApplication: function (group, application) {

            application.value = false;
            window.GCM.apps.set(application.appName, false)

            jQuery.each(application.cookies, function (index, cookie) {
                window.GCMHTML.deactivateCookie(group.gcmGroup.htmlid, cookie.htmlid, group.htmlGroup);
            });


            var appKeys = Object.keys(group.gcmGroup.apps);

            if (appKeys.length == 1) {
                this.deactivateGroupSwitch(group);
            } else {

                var result = false;

                appKeys.forEach(function (app) {
                    var application = group.gcmGroup.apps[app];

                    if (application.value) {
                        result = true;
                    }
                });

                if (!result) {
                    this.deactivateGroupSwitch(group);
                }
            }
        },
        deactivateCookiesAll: function (except) {

            if (typeof except === 'undefined' || except === null) {
                excepts = [];
            }

            jQuery.each(this.groups, function (index, group) {

                if (!group.gcmGroup.protected) {

                    // deactivate group
                    if (group.gcmGroup.value) {

                        window.GCMHTML.deactivateGroupSwitch(group);

                        if (excepts.length > 0) {

                            excepts.forEach(function (except) {

                                var appKeys = Object.keys(group.gcmGroup.apps);

                                appKeys.forEach(function (app) {
                                    var appObject = group.gcmGroup.apps[app];
                                    var cookieKeys = Object.keys(appObject.cookies);

                                    cookieKeys.forEach(function (cookie) {
                                        // TODO
                                        if (except == cookie) {
                                            window.GCMHTML.activateCookie(group.gcmGroup.htmlid, appObject.cookies[cookie].htmlid);
                                        }
                                    });
                                });
                            });
                        }
                    }
                }
            });

            /*
            jQuery.each(this.applications, (index, app) => {

                if (!app.gcmApplication.protected) {

                    var htmlApp = app.htmlApplication;
                    $htmlApp = jQuery(htmlApp);

                    // deactivate application
                    if (app.gcmApplication.value) {
                        app.gcmApplication.value = false;
                        this.deactivateApplication(app);
                    }

                    jQuery.each(app.gcmApplication.cookies, (index, cookie) => {
                        this.deactivateCookie(app.gcmApplication.htmlid, cookie.htmlid);
                    });
                }
            });
            */
        },
        renderGroupHTMLFields: function (group) {

            var gcmGroup = group.gcmGroup;
            var htmlGroup = group.htmlGroup;

            $htmlGroup = jQuery(htmlGroup);

            $htmlGroup.find('.apa-consent-itemTitle').text(gcmGroup.label);
            $htmlGroup.find('.apa-consent-itemText').text(gcmGroup.description);

            // TODO BUG... check applications
            if (gcmGroup.protected) {
                // nothing to do...
                $groupEntry.find('.apa-consent-itemSwitch').removeClass('apa-consent-itemSwitchON');
                $groupEntry.find('.apa-consent-itemSwitch').removeClass('apa-consent-itemSwitchOFF');
            } else if (gcmGroup.value) {
                $groupEntry.find('.apa-consent-itemSwitch').addClass('apa-consent-itemSwitchON');
                // window.GCMHTML.activateGroupSwitchOnly(group);
            } else {
                $groupEntry.find('.apa-consent-itemSwitch').addClass('apa-consent-itemSwitchOFF');
                // window.GCMHTML.deactivateGroupSwitchOnly(group);
            }

            /*
            // TODO ... check the following line...
            jQuery('body').on('click', $groupEntry.find('.apa-consent-itemSwitch')[0], function (event) {
                window.GCM.apps.set(application.appid, !gcmApplication.value);
            });
            */

            var appKeys = Object.keys(gcmGroup.apps);

            appKeys.forEach(function (application, i) {


                var appObject = gcmGroup.apps[application];
                appObject.appName = application;
                var keys = Object.keys(appObject.cookies);

                keys.forEach(function (cookie, i) {
                    //jQuery.each(keys, function (i, cookie) {

                    var gcmCookie = appObject.cookies[cookie];

                    var cookieItemNewId = null;
                    var htmlCookie = null;

                    if (gcmCookie.appid === 'essential') {
                        htmlCookie = jQuery('#prototypeAppEntryProtectedCookieItem').clone();
                        cookieItemNewId = 'prototypeAppEntryProtectedCookieItem' + '_' + application + '-' + i;
                    } else {
                        htmlCookie = jQuery('#prototypeAppEntryCookieItem').clone();
                        cookieItemNewId = 'prototypeAppEntryCookieItem' + '_' + application + '-' + i;
                    }

                    gcmCookie['htmlid'] = cookieItemNewId;

                    htmlCookie.attr('id', cookieItemNewId);


                    $cookieItem = jQuery(htmlCookie);

                    /*
                    if (!gcmApplication.value) {
                        this.cookieToggleOff(htmlCookie[0]);
                    }*/

                    $cookieItem.find('.apa-consent-subItemTitle > span').text(gcmCookie.label);

                    if (gcmCookie.description != null && gcmCookie.description.length > 0) {
                        $cookieItem.find('.apa-consent-P').text(gcmCookie.description);
                    }

                    $cookieItem.css('display', 'block');

                    $htmlGroup.find('.apa-consent-cookie-items').append(jQuery('<div>').append($cookieItem).html());

                    setTimeout(function () {
                        window.GCMHTML.initGroupCookieToggleSwitch(group, appObject, cookie, gcmCookie, htmlCookie[0])
                    }, 500);
                });
            });

            jQuery('.apa-consent-items').append(jQuery('<div>').append($htmlGroup).html());
        },
        ini: function () {

            /**
             * prepare HTML
             */

            jQuery('.apa-consent-bannerText').html(this.bannerText);

            if (this.showOrHideBanner()) {

            } else {
                // cookie banner is hidden.
            }

            this.eventButtonAccept();
            this.eventButtonSaveSettings();

            var groups = window.GCM.groups.getList();

            var groupKeys = Object.keys(groups);

            jQuery.each(groupKeys, function (index, group) {

                // group is a fieldname
                var groupObject = groups[group];

                var htmlGroupEntry = null;
                var newId;
                if (!groupObject.protected) {
                    newId = 'prototypeAppEntry' + '-' + index;

                    htmlGroupEntry = jQuery('#prototypeAppEntry').clone();

                } else {
                    newId = 'prototypeAppEntryProtected' + '-' + index;

                    htmlGroupEntry = jQuery('#prototypeAppEntryProtected').clone();
                }

                $groupEntry = jQuery(htmlGroupEntry);
                $groupEntry.attr('id', newId);

                $groupEntry.attr('data-appid', group);

                groupObject.htmlid = newId;

                window.GCMHTML.loadGroup(window.GCMHTML.addGroup(group, groupObject, htmlGroupEntry[0]));

            });

            jQuery(this.bannerButtonOpen).click(function () {
                window.GCMHTML.showBanner();
            });

            /*
            if(!this.isCookiesAllowed()) {
                this.hidePrefDialogRoundButtonOpen();
            }
            */
            jQuery(this.prefDialogRoundButtonOpen).click(function () {
                window.GCMHTML.showPrefDialog();
            });

            jQuery(this.prefDialogButtonOpen).click(function (event) {
                window.GCMHTML.showPrefDialog();
            });

            jQuery(this.prefDialogButtonDetails).click(function (event) {
                window.GCMHTML.showPrefDialog();
            });


            // '.apa-consent-linkDetails' isnt available before yet, it gets dynamically loaded, so we need to set a timeout
            setTimeout(function () {
                var prefDialogHyperlinkDetails = jQuery('.apa-consent-linkDetails')[0];
                jQuery(prefDialogHyperlinkDetails).click(function (event) {
                    window.GCMHTML.showPrefDialog();
                });
            }, 500);


            jQuery(this.prefDialogButtonMobileClose).click(function () {
                window.GCMHTML.hidePrefDialog();
            });

            jQuery(this.prefDialogButtonClose).click(function () {
                window.GCMHTML.hidePrefDialog();
            });

            jQuery('[id*=prototypeAppEntry-] .apa-consent-itemTitle, [id*=prototypeAppEntryProtected-] .apa-consent-itemTitle').each(function (index, item) {
                var selector = window.GCMHTML.getXPath(item);

                if (selector.trim().length > 0) {

                    jQuery(document).on('click', selector, function (event) {
                        var parent = event.target.parentNode;
                        $parent = jQuery(parent);

                        if ($parent.hasClass('apa-consent-itemSubItemsON')) {
                            $parent.removeClass('apa-consent-itemSubItemsON');
                        } else {
                            $parent.addClass('apa-consent-itemSubItemsON');
                        }
                    });
                }
            });
        }
    }

    window.GCMHTML.ini();

    jQuery('.cookie-pref').click(function () {
        jQuery('.apa-consent-wrapper').removeClass('testOFF');
        jQuery('.apa-consent-dialogWrapper').removeClass('testOFF');

    });
})
;


jQuery(document).ready(function () {


    <!-- youtube banner -->


    if (window.GCM.apps.get('youtube') === true) {
        activateYouTube();
    } else {

        jQuery('iframe[src*=youtube]').each(function (index, element) {
            console.log(element);
			jQuery(this).data('src', jQuery(this).attr('src'));
			jQuery(this).attr('src', '');


            jQuery(jQuery(this).parent()).addClass('youtube-wrapper');
            jQuery(jQuery(this).parent()).css('background-image', 'url(/wp-content/themes/apa-business-report/images/youtube-video-banner.png)');
            jQuery(jQuery(this).parent()).css('height', '315px');
            jQuery(jQuery(this).parent()).prepend('<a class="preferences-button hide" href="javascript:void(0)">Cookie-Pr&auml;ferenzen</a>');
            jQuery(jQuery(this).parent()).prepend('<h2>Zum laden des Videos, bitte YouTube Cookies akzeptieren.</h2>');

            jQuery(this).hide(); // ('display', 'none');


            jQuery('.preferences-button').click(function () {
                jQuery('.apa-consent-wrapper').removeClass('testOFF');
                jQuery('.apa-consent-dialogWrapper').removeClass('testOFF');
            });

        });

        /*
        jQuery('iframe[data-src*=youtube]').each(function (index, element) {
        });*/
    }
    jQuery(document).on('click', '.btnAcceptYT', function () {
        if (window.GCM.apps.set('youtube', true)) {
            activateYouTube();
        }
    });

    function activateYouTube() {
        jQuery('iframe[data-src*=youtube]').each(function (index, iFrame) {

            jQuery(iFrame).attr('src', jQuery(iFrame).data('src'));
            jQuery(this).css('display', 'block');
        });

    }
});

